#include <stdio.h>
#include <string.h>
#include <mhash.h>

#if 0
#include <openssl/sha.h>
unsigned char *WIIMM_SHA1(const unsigned char *d, size_t n, unsigned char *md)
{
	WIIMM_SHA_CTX c;
	static unsigned char m[SHA_DIGEST_LENGTH];

	if (md == NULL) md=m;
	if (!WIIMM_SHA1_Init(&c))
		return NULL;
	WIIMM_SHA1_Update(&c,d,n);
	WIIMM_SHA1_Final(md,&c);
	return(md);
}
#endif

unsigned char *WIIMM_SHA1(const unsigned char *d, size_t n, unsigned char *md)
{
	MHASH td;
	if ((td = mhash_init(MHASH_SHA1)) == MHASH_FAILED)
		return NULL;
	mhash(td, d, n);
	mhash_deinit(td, md);
	return(md);
}

#if 0
int main() {
	char *bleh = "22:40 → fritz09 [~Adium@port-5452.pppoe.wtnet.de] has joined #29c3";
	char md[1024] = { 0 };
	WIIMM_SHA1(bleh, strlen(bleh), md);
	printf("md = %s\n", md);
	memset(md, '\0', sizeof(md));
	WIIMM_SHA1_ssl(bleh, strlen(bleh), md);
	printf("md = %s\n", md);
}
#endif
